 ;
;**************************************************************************************************************************************************
;*
;*	PAL VERTICAL COLOUR BAR GENERATOR 
;*
;*	Author:	Serasidis Vasilis
;*	Writed: 	14-08-2003 with AVR Studio 4.02
;*	Version:	0.1 beta
;*	Target:	AT90S2313-10 overclocked at 17.734475 MHz 
;*	Web site:	http://www.serasidis.gr
;*	eMail:	info@serasidis,gr	
;*	
;*
;*	Adopted for Tiny2313-20PU by LC
;*
;*	This PAL vertical colour bar genarator based on AT90s2313-10 MCU, overclocked at 17.734475 MHz !!!
;*	because there is no AT90Sxxxx at this frequency. Near to 17 MHz is AT90S1200-16 but i could`n find it on the market. 
;*	For Analog to Digital converter i used R2R-ladders with 500 ohm and 1 Kohm resistors connected to PortD.
;*
;*	This source code its not complete. Its working, but the colour-hue its not the same in all TVs.   
;*	The colors from the left of the screen are: white, magenta, orange, green, blue and black. 
;*	I leave this source code, to continue it, someone else. 
;*	I dont make any economy to the flash-memory. I leave the code extended, for modifications.
;*
;*	Remember!!!
;*	 - The timing of the instructions is very important.
;* 	 - Do not remove any 'Nop' intruction without replace it with someone else instruction. 
;*
;*	Inform me if you improve this source code
;*	Good luck
;*
;***********************************************************************************************************************************************
;
;
;
;
;
.include"tn2313def.inc"

.def	bottom		=r2
.def	blank		=r3
.def	black 		=r4
.def	white	 	=r5
.def	one		=r6

.def	c_burst_hi	=r23
.def	c_burst_lo 	=r24
.def	next0		=r25
.def	next		=r26


.def	temp 		=r16
.def	delay		=r17
.def	c_burst_phase	=r18
.def	c_bar_hi	=r19
.def	c_bar_lo 	=r20
.def	c_bar_avg	=r21
.def	color_bar	=r22




	ldi	temp,RAMEND
	out	SPL,temp	;Init Stack Pointer


	ldi     temp, 0b01111111        ;set port D bits to outputs
	out     DDRD, temp

;----------------------------------------------------------------------
reset:
	clr	bottom		;zero voltage level

	ldi	temp,6
	mov	black,temp

	ldi	temp,1
	mov	one,temp

	ldi	temp,8		;low voltage level (0.2V - black color)
	mov	blank,temp

	ldi	temp,30
	mov	white,temp		;high voltage level (1.2V - white color)


	ldi	c_burst_phase,1		;

	ldi	temp,10 		;High level for color carrier (1V)
	mov	c_burst_hi,temp

	ldi	temp,6
	mov	c_burst_lo,temp		;Low level for color carrier (0.38V)

	ldi	c_bar_hi,28 	;High level for color bar
	ldi	c_bar_lo,9	;Low level for color bar
	ldi	c_bar_avg,14	;color bar avg

	

start:	ldi	color_bar,4 	;Number of color bars (4 color bars + 1 white + 1 black)
	nop			
	out	portd,blank

	ldi	delay,2		;	
	rcall	delay3x		;3x2+8=14 cycles

	out	portd,bottom	;start the orizontal sinchronization

	ldi	delay,23
	rcall	delay3xp2	;delay 3x plus two +8 = 79

	add	next0,one	
	adc	next,bottom	

	out	portd,blank

	ldi	delay,2	
	rcall	delay3x		;3x2+8=14 cycles delay

	sbrs	next,7			;test bit7 of variable next
	rjmp	color_burst
	nop

	dec	c_burst_phase		;starting color-burst with 135 deg the 1st scan-line. To the 2th scan-line add 90 deg more. Sum 90+135=225 deg.
	breq	color_burst		;If its on the first scan-line, go to 'color_burst'
	ldi	c_burst_phase,1		;if its on the even scan-line...
	nop
	nop
					;2 or 4 cycles
color_burst:
	out	portd,c_burst_hi
	out	portd,blank
	out	portd,c_burst_lo
	out	portd,blank
	out	portd,c_burst_hi
	out	portd,blank
	out	portd,c_burst_lo
	out	portd,blank
	out	portd,c_burst_hi
	out	portd,blank
	out	portd,c_burst_lo
	out	portd,blank
	out	portd,c_burst_hi
	out	portd,blank
	out	portd,c_burst_lo
	out	portd,blank
	out	portd,c_burst_hi
	out	portd,blank
	out	portd,c_burst_lo
	out	portd,blank
	out	portd,c_burst_hi
	out	portd,blank
	out	portd,c_burst_lo
	out	portd,blank
	out	portd,c_burst_hi
	out	portd,blank
	out	portd,c_burst_lo
	out	portd,blank
	out	portd,c_burst_hi
	out	portd,blank
	out	portd,c_burst_lo
	out	portd,blank
	out	portd,c_burst_hi
	out	portd,blank
	out	portd,c_burst_lo
	out	portd,blank
	out	portd,c_burst_hi
	out	portd,blank
	out	portd,c_burst_lo
	out	portd,blank

	out	portd,white	;Show the white color (1st color bar)

	ldi	delay,66
	rcall	delay3xp1	;3x66+1+8=207

	out	portd,black

	sbrc	next,7
	rjmp	color_carrier
	nop
	dec	c_burst_phase	
	breq	color_carrier	
	ldi	c_burst_phase,1	
	nop
	nop

color_carrier:	
	out	portd,c_bar_hi
	out	portd,c_bar_avg
	out	portd,c_bar_lo
	out	portd,c_bar_avg
	out	portd,c_bar_hi
	out	portd,c_bar_avg
	out	portd,c_bar_lo
	out	portd,c_bar_avg
	out	portd,c_bar_hi
	out	portd,c_bar_avg
	out	portd,c_bar_lo
	out	portd,c_bar_avg
	out	portd,c_bar_hi
	out	portd,c_bar_avg
	out	portd,c_bar_lo
	out	portd,c_bar_avg
	out	portd,c_bar_hi
	out	portd,c_bar_avg
	out	portd,c_bar_lo
	out	portd,c_bar_avg
	out	portd,c_bar_hi
	out	portd,c_bar_avg
	out	portd,c_bar_lo
	out	portd,c_bar_avg
	out	portd,c_bar_hi
	out	portd,c_bar_avg
	out	portd,c_bar_lo
	out	portd,c_bar_avg
	out	portd,c_bar_hi
	out	portd,c_bar_avg
	out	portd,c_bar_lo
	out	portd,c_bar_avg
	out	portd,c_bar_hi
	out	portd,c_bar_avg
	out	portd,c_bar_lo
	out	portd,c_bar_avg
	out	portd,c_bar_hi
	out	portd,c_bar_avg
	out	portd,c_bar_lo
	out	portd,c_bar_avg

	out	portd,c_bar_hi
	out	portd,c_bar_avg
	out	portd,c_bar_lo
	out	portd,c_bar_avg
	out	portd,c_bar_hi
	out	portd,c_bar_avg
	out	portd,c_bar_lo
	out	portd,c_bar_avg
	out	portd,c_bar_hi
	out	portd,c_bar_avg
	out	portd,c_bar_lo
	out	portd,c_bar_avg
	out	portd,c_bar_hi
	out	portd,c_bar_avg
	out	portd,c_bar_lo
	out	portd,c_bar_avg
	out	portd,c_bar_hi
	out	portd,c_bar_avg
	out	portd,c_bar_lo
	out	portd,c_bar_avg
	out	portd,c_bar_hi
	out	portd,c_bar_avg
	out	portd,c_bar_lo
	out	portd,c_bar_avg
	out	portd,c_bar_hi
	out	portd,c_bar_avg
	out	portd,c_bar_lo
	out	portd,c_bar_avg
	out	portd,c_bar_hi
	out	portd,c_bar_avg
	out	portd,c_bar_lo
	out	portd,c_bar_avg
	out	portd,c_bar_hi
	out	portd,c_bar_avg
	out	portd,c_bar_lo
	out	portd,c_bar_avg
	out	portd,c_bar_hi
	out	portd,c_bar_avg
	out	portd,c_bar_lo
	out	portd,c_bar_avg

	out	portd,c_bar_hi
	out	portd,c_bar_avg
	out	portd,c_bar_lo
	out	portd,c_bar_avg
	out	portd,c_bar_hi
	out	portd,c_bar_avg
	out	portd,c_bar_lo
	out	portd,c_bar_avg
	out	portd,c_bar_hi
	out	portd,c_bar_avg
	out	portd,c_bar_lo
	out	portd,c_bar_avg
	out	portd,c_bar_hi
	out	portd,c_bar_avg
	out	portd,c_bar_lo
	out	portd,c_bar_avg
	out	portd,c_bar_hi
	out	portd,c_bar_avg
	out	portd,c_bar_lo
	out	portd,c_bar_avg
	out	portd,c_bar_hi
	out	portd,c_bar_avg
	out	portd,c_bar_lo
	out	portd,c_bar_avg
	out	portd,c_bar_hi
	out	portd,c_bar_avg
	out	portd,c_bar_lo
	out	portd,c_bar_avg
	out	portd,c_bar_hi
	out	portd,c_bar_avg
	out	portd,c_bar_lo
	out	portd,c_bar_avg
	out	portd,c_bar_hi
	out	portd,c_bar_avg
	out	portd,c_bar_lo
	out	portd,c_bar_avg
	out	portd,c_bar_hi
	out	portd,c_bar_avg
	out	portd,c_bar_lo
	out	portd,c_bar_avg

	out	portd,c_bar_hi
	out	portd,c_bar_avg
	out	portd,c_bar_lo
	out	portd,c_bar_avg
	out	portd,c_bar_hi
	out	portd,c_bar_avg
	out	portd,c_bar_lo
	out	portd,c_bar_avg
	out	portd,c_bar_hi
	out	portd,c_bar_avg
	out	portd,c_bar_lo
	out	portd,c_bar_avg
	out	portd,c_bar_hi
	out	portd,c_bar_avg
	out	portd,c_bar_lo
	out	portd,c_bar_avg
	out	portd,c_bar_hi
	out	portd,c_bar_avg
	out	portd,c_bar_lo
	out	portd,c_bar_avg
	out	portd,c_bar_hi
	out	portd,c_bar_avg
	out	portd,c_bar_lo
	out	portd,c_bar_avg
	out	portd,c_bar_hi
	out	portd,c_bar_avg 	;146 cycles
	out	portd,black

	dec	color_bar	;check if is the 5th color-bar (blue)
	breq	black_bar		;if yes, go to start again from the beginning
	rjmp	color_carrier	;if not, go to show the next color-bar (151 cycles)
;------------------

black_bar:
	out	portd,black	;Show the black color (6th color bar)

	ldi	delay,49
	rcall	delay3xp2	;3x49+2+8=157

	rjmp	start

;--------------------------------------------------------------
; Delay routine: Entry with delay value loaded, takes 8 cycles
;                overhead (load value, call, ret) 
;
;--------------------------------------------------------------

delay3xp2:
	nop
delay3xp1:
	nop
delay3x:
	dec	delay		;1 cycle
	brne	delay3x		;2 for jump
	nop			;makeup for 3X
	ret
